/*
	oCit@Cxilinx .ucft@CBlockRAMf[^ɖߍ

	Copyright(C) 2002 Tatsuyuki Satoh

	Ef[^͂RQoCgPsƂāA
	INST "[name][bb]" INIT_[ss] = [data]
	ƂsǉB

	[name] : p[^Ŏw肳ꂽ
	[bb]   : RAMubN̒ʂԍAPUiQ00珇ԂɐB
	[ss]   : ubNZNVA00`0f̒lB
	[data] : 16i64A32oCg̃f[^AMSBt@[Xg

	E.ucf̊̒`s͍폜B
		ƂẮA'INST "[name]'s̐擪ɌƂ

*/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#define TEMP_NAME "tempucf.ucf"

unsigned char dbuf[32]; /* binaly data line buffer */
char buf[4096]; /* line buffer */
char delstr[64];
char fname[128];

int main( int argc,char **argv )
{
	FILE *fpbin,*fpucf,*fpout;
	int len;
	char *sptr;
	int i,section;
	int num_copy,num_delete,num_add;

	printf("binucf test vertsion\nCopyright(c) 2002 Tstsuyuki Satoh\n");

	if(argc < 4)
	{
		printf("use:binucf [binaryfile] [ucf-in] [component_name]");
		return 1;
	}

	//bin
	fpbin=fopen(argv[1],"rb");
	if(!fpbin)
	{
		printf("can't open binary file %s",argv[1]);
		return 1;
	}
	// ucf source
	fpucf=fopen(argv[2],"rt");
	if(!fpucf)
	{
		printf("can't open ucf file %s",argv[2]);
		fclose(fpbin);
		return 1;
	}
	// ucf dst
	fpout=fopen(TEMP_NAME,"wt");
	if(!fpout)
	{
		printf("can't open file %s",TEMP_NAME);
		fclose(fpbin);
		fclose(fpucf);
		return 1;
	}
	// build delete line
	sprintf(delstr,"INST \"%s",argv[3]);

printf("'%s'\n",delstr);


	// copy ucf file & remove old initialize data
	num_copy = num_delete = num_add = 0;
	while( fgets(buf,sizeof(buf),fpucf) != NULL)
	{
		// check data line
		if( !strncmp(buf,delstr,strlen(delstr)) )
		{
			num_delete++;
		}
		else
		{
			num_copy++;
			fprintf(fpout,"%s",buf);
		}
	}
	// add binary data
	section = 0;
	while(1)
	{
		memset(dbuf,0,32);
		len=fread(dbuf,1,32,fpbin);
		if(len==0)
			break;
		//
		sprintf(buf,"%s%02x\" INIT_%02x = ",delstr,section/16,section&15);
		sptr = buf + strlen(buf);
		// build 32byte data value
		for(i=31;i>=0;i--)
		{
			sprintf(sptr,"%02x",dbuf[i]);
			sptr += 2;
		}
		// write
		fprintf(fpout,"%s;\n",buf);
		num_add++;
		// section / block
		section++;
	}
	fclose(fpbin);
	fclose(fpucf);
	fclose(fpout);

	printf("copy lines %d\n",num_copy);
	printf("delete lines %d\n",num_delete);
	printf("add lines %d\n",num_add);

	/* update ucf file */
	remove(argv[2]);
	rename(TEMP_NAME,argv[2]);

	printf("complete!\n");

	return 0;
}